$(function()
{
	var _canvas;
	var _context;
	var _audio = [];
	var _input = [];
	var _loaded = 0;
	var _current = -1;
	var _scale = 1.0;
	var _stage = 0;

	function resize()
	{
		var w = $('body').width();
		var h = $('body').height();
		if ( 1080/w < 1650/h )
		{
			_scale = h/1650;
			_canvas.width = 1080*_scale;
			_canvas.height = h;
		}
		else
		{
			_scale = w/1080;
			_canvas.width = w;
			_canvas.height = 1650*_scale;
		}
	}

	function initCanvas()
	{
		_canvas = $('#Canvas2D')[0];
		if ( !_canvas || !_canvas.getContext )
		{
			return false;
		}
		resize();
		_context = _canvas.getContext('2d');
		_context.scale(_scale,_scale);
		$(".title").each(function(i){
			$("<img>").attr("src", this.src).load(function(){
				if ( ++_loaded >= 3 )
				{
					_loaded = 0;
					initComplete();
				}
			});
		});
	}

	function initComplete()
	{
		_context.drawImage($(".title")[0],0,0);
		var agent = navigator.userAgent;
	    if(agent.search(/iPhone/) != -1 || agent.search(/iPad/) != -1 || agent.search(/iPod/) != -1 || agent.search(/Android/) != -1)
		{
			$(_canvas).on('touchstart',onStart);
		}
		else
		{
			$(_canvas).on('click',onStart);
		}
	}

	function onStart()
	{
		_current = 0;
		_audio = $("audio").get();
		for ( i = 0; i < _audio.length; i++ ) _audio[i].load();
		loadImages(_stage);
	}

	var _imageArray = ["Clown","Dog","Building"];

	function loadImages(stage)
	{
		playAudio(0);
		_canvas.style.display = "none";
		var agent = navigator.userAgent;
	    if(agent.search(/iPhone/) != -1 || agent.search(/iPad/) != -1 || agent.search(/iPod/) != -1 || agent.search(/Android/) != -1)
		{
			$(_canvas).off('touchstart');
		}
		else
		{
			$(_canvas).off('click');
		}
		_input = [];
		$("img.answer").empty();
		for ( var i = 0; i < 2; i++ ) loadAnswerImage(i);
	}

	function loadAnswerImage(index)
	{
		var url = "images/"+_imageArray[_stage]+(index==0?"/Answer.png":"/Answer2.png");
		var imgPreloader = new Image();
		$(imgPreloader).on('load', function()
		{
			$("img.answer").eq(index).attr({'src':url});
			_context.drawImage(this,0,0);
			_input[index] = _context.getImageData(0,0,this.width,this.height);
			_context.clearRect(0,0,this.width,this.height);
			completeGame();
		}).attr('src', url);
	}

	function completeGame()
	{
		if ( ++_loaded >= 2 )
		{
			_loaded = 0;
			$("img.game").empty();
			for ( var i = 0; i < 4; ++i ) loadGameImage(i);
		}
	}

	function loadGameImage(index)
	{
		var url = "images/"+_imageArray[_stage]+"/Flip"+index+".jpg";
		var imgPreloader = new Image();
		$(imgPreloader).on('load', function()
		{
			$("img.game").eq(index).attr({'src':url});
			if ( ++_loaded >= 4 )
			{
				_loaded = 0;
				complete();
			}
		}).attr('src', url);
	}

	function complete()
	{
		_context.drawImage($(".game")[0],0,0);
		var agent = navigator.userAgent;
	    if(agent.search(/iPhone/) != -1 || agent.search(/iPad/) != -1 || agent.search(/iPod/) != -1 || agent.search(/Android/) != -1)
		{
			_canvas.addEventListener('touchstart',onTouch,false);
		}
		else
		{
			$(_canvas).on('click',onClick);
		}
		_canvas.style.display = "block";
	}

	function playAudio(mp3)
	{
		try
		{
			_audio[mp3].currentTime = 0;
			_audio[mp3].play();
		}
		catch (e)
		{
			_audio[mp3].play();
		}
	}

	function onClick(event)
	{
		var x,y;
		if ( event.offsetX != undefined )
		{
			x = event.offsetX;
			y = event.offsetY;
		} else {
			var rect = event.target.getBoundingClientRect();
			x = event.clientX - rect.left;
			y = event.clientY - rect.top;
		}

		answer(~~x,~~y);
	}

	function onTouch(event)
	{
		var rect = event.target.getBoundingClientRect();
		var x = event.touches[0].clientX - rect.left;
		var y = event.touches[0].clientY - rect.top;
		answer(~~x,~~y);
	}

	function answer(x,y)
	{
		if ( x < 0 || x >= _canvas.width || y < 0 || y >= _canvas.height )
		{
			return;
		}

		switch ( _current )
		{
		case 0:
			if ( _input[0].data[(y*_input[0].width+x)*4] > 32 )
			{
				playAudio(1);
				_current = 2;
				_context.drawImage($(".game")[1],0,0);
			}
			else
			{
				playAudio(2);
				_current = 1;
				_context.drawImage($(".game")[3],0,0);
			}
			break;

		case 1:
			if ( _input[1].data[(y*_input[1].width+x)*4] > 32 )
			{
				playAudio(1);
				_current = 5;
				_context.drawImage($(".game")[2],0,0);
			}
			else
			{
				playAudio(2);
				_context.drawImage($(".game")[0],0,0);
				_current = 0;
			}
			break;

		case 2:
			playAudio(3);
			_context.drawImage($(".game")[3],0,0);
			_current = 3;
			break;

		case 3:
			playAudio(4);
			_context.drawImage($(".game")[2],0,0);
			_current = 4;
			break;

		case 4:
		case 7:
			if ( _stage == _imageArray.length - 1 )
			{
				playAudio(2);
		    	_context.drawImage($(".title")[2], 0, 0);
				_current = 9;
				_stage = 0;
			}
			else
			{
				playAudio(5);
		    	_context.drawImage($(".title")[1], 0, 0);
				_current = 8;
				_stage++;
			}
			break;

		case 5:
			playAudio(3);
			_context.drawImage($(".game")[0],0,0);
			_current = 6;
			break;

		case 6:
			playAudio(4);
			_context.drawImage($(".game")[1],0,0);
			_current = 7;
			break;

		case 8:
			_current = 0;
			loadImages(_stage);
			break;

		case 9:
			playAudio(2);
			initComplete();
			break;
		}
	}

	initCanvas();
});
